#include <bits/stdc++.h>
#define mp make_pair
using namespace std;

long long n, q, p[1010], s[1010], t, u, v;
char cha;

int komp(int a) {
    while(a!=p[a]) a=p[a];
    return a;
}

void merrge(int a, int b) {
    a=komp(a);
    b=komp(b);
    if(s[b]>s[a]) {
        int t=a;
        a=b;
        b=t;
    }
    p[b]=a;
    s[a]+=s[b];
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin>>n>>q;
    for(int i=1; i<=n; i++) {
        p[i]=i;
        s[i]=1;
    }
    while(q--) {
        cin>>t>>u>>v;
        if(t==1) {
            cin>>cha;
            merrge(u, v);
        }
        else {
            cout<<(komp(u)==komp(v))<<'\n';
        }
    }
    return 0;
}